/*
 *  SW
 *  Copyright 1989-92 by Brent Barrett, All Rights Reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <dir.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <io.h>
#include <alloc.h>

#include "scrstdio.h"
#include "proto.h"

struct BOOL_FLAGS {
    unsigned int msg_on : 1; /* is there a message being displayed now? */
    unsigned int quit_to_dos : 1; /* ready to quit to DOS? */
    unsigned int reload_dir : 1; /* ready to reload directory? */
    unsigned int fill_dir : 1; /* ready to fill screen with directory? */
    unsigned int exit_here : 1; /* do we exit at this disk/directory? */
};

struct NCD_HEADER {
    char name[5];
    int count;
    int huh;
};
struct NCD_ENTRY {
    char name[13];
    char level;
    char huh[2];
};

/*
 *  configuration structure and definitions
 */
enum config_colors {
/*
 * base window attributes
 */
  CO_FILE,
  CO_HIDDEN,
  CO_DIR,
  CO_SELECT,
  CO_SCREEN_BORDER,
  CO_TAGGED,
/*
 *  menu attributes
 */
  CO_MENU_BORDER,
  CO_MENU_ITEM,
  CO_MENU_SELECT,
  CO_MENU_INACTIVE,
/*
 *  message window attributes
 */
  CO_MSG_BORDER,
  CO_MSG_TEXT,
/*
 *  prompt window attributes
 */
  CO_PROMPT_BORDER,
  CO_PROMPT_TEXT,
  CO_PROMPT_INPUT,
/*
 *  area attributes
 */
  CO_STATUS_AREA,
  CO_VOLUME_AREA,
  CO_ERROR_AREA
};

#define MAX_COLOR 18

struct RUN_INFO {
    char ext[5];
    char fmt[76];
    unsigned wait : 1;
    unsigned exit : 1;
    unsigned reserved : 6;
};

#define MAX_AUTORUN 25

#define SEQ_COMPRESSED  0
#define SEQ_RESET       1
#define MAX_SEQUENCES   2
#define MAX_SEQ_CHARS   16

struct CONFIGURATION {
    int color[MAX_COLOR];
    unsigned sound : 1;
    unsigned sort : 1;
    unsigned bios : 1;
    unsigned mono : 1;
    unsigned verify_overwrite : 1;
    unsigned verify_delete : 1;
    unsigned exit_origin : 1;
    unsigned align_ext : 1;
    int msg_delay;
    int lock_keys;
    int screen_blank;
    char printer_seq[MAX_SEQUENCES][MAX_SEQ_CHARS];
    int col_sep_char;
    int label_lines;
    int label_rows;
    int label_skip;
    char sort_method;
    char editor[76];
    char lister[76];
    char help_file[76];
    char tree_file[76];
    char homearea[70];
    char out_file[76];
    struct RUN_INFO run[MAX_AUTORUN];
};

/*
 *  file entry structure
 */
struct FILE_ENTRY {
    char name[9];
    char ext[5];
    unsigned long size;
    unsigned char attr;
    int da_year;
    int da_mon;
    int da_day;
    int ti_hour;
    int ti_min;
    int ti_sec;
    unsigned new_tag : 1;
    unsigned old_tag : 1;
    unsigned dir : 1;
};

/*
 *  dos_file_type() return values
 */
#define T_FILE 0
#define T_DIR 1
#define T_NONE -1

#define FILE_BUF_LEN 30720

/*
 *  macros
 */
#define MAX_MACROS  40

struct MACRO_RECORD {
    char name[19];
    struct KEY instr[240];
    unsigned char play_ptr;
    unsigned char play_max;
    char calling_macro; /* this is -1 if no macro called it */
    unsigned playing : 1;
    unsigned unused7 : 1;
    unsigned unused6 : 1;
    unsigned unused5 : 1;
    unsigned unused4 : 1;
    unsigned unused3 : 1;
    unsigned unused2 : 1;
    unsigned unused1 : 1;
};

#define ONE_SECOND  18
#define HALF_SECOND 9
#define HALF_MINUTE 540L
#define ONE_MINUTE  1080L

#define STATUS_AREA 0
#define ERROR_AREA  1
#define MAX_AREAS   2

#define FILENAME_SORT 1
#define FILEEXT_SORT  2
#define FILEDATE_SORT 3
#define FILESIZE_SORT 4
#define MAX_SORTS     4

#define CONTINUOUS  -1
#define ABORT       -2

#define free_space(d, p) disk_space((d), (p), YES)

